Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 75772)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -4342,38 +3829,40 @@
         case FileHardLinkInformation:
         {
             FILE_LINKS_INFORMATION* fli = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileHardLinkInformation\n");
-            
+
+            ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
             Status = fill_in_hard_link_information(fli, fileref, Irp, &length);
-            
+            ExReleaseResourceLite(&Vcb->tree_lock);
+
             break;
         }
-            
+
         case FileNormalizedNameInformation:
         {
             FILE_NAME_INFORMATION* fni = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileNormalizedNameInformation\n");
-            
+
             Status = fill_in_file_name_information(fni, fcb, fileref, &length);
-            
+
             break;
         }
 #endif
-            
+
 #if (NTDDI_VERSION >= NTDDI_WIN7)
         case FileStandardLinkInformation:
         {
             FILE_STANDARD_LINK_INFORMATION* fsli = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileStandardLinkInformation\n");
-            
+
             Status = fill_in_file_standard_link_information(fsli, fcb, ccb->fileref, &length);
-            
+
             break;
         }
-        
+
         case FileRemoteProtocolInformation:
             TRACE("FileRemoteProtocolInformation\n");
             Status = STATUS_INVALID_PARAMETER;
@@ -4381,94 +3870,101 @@
 #endif
 
 #if (NTDDI_VERSION >= NTDDI_WIN10)
+#ifndef _MSC_VER
 #pragma GCC diagnostic push
 #pragma GCC diagnostic ignored "-Wswitch"
+#endif
         case FileIdInformation:
         {
             FILE_ID_INFORMATION* fii = Irp->AssociatedIrp.SystemBuffer;
-            
+
             if (IrpSp->Parameters.QueryFile.Length < sizeof(FILE_ID_INFORMATION)) {
                 WARN("overflow\n");
                 Status = STATUS_BUFFER_OVERFLOW;
                 goto exit;
             }
-            
+
             TRACE("FileIdInformation\n");
-            
-            Status = fill_in_file_id_information(fii, fcb, &length);  
-            
+
+            Status = fill_in_file_id_information(fii, fcb, &length);
+
             break;
         }
-#pragma GCC diagnostic pop            
+#ifndef _MSC_VER
+#pragma GCC diagnostic pop
 #endif
-        
+#endif
+
         default:
             WARN("unknown FileInformationClass %u\n", IrpSp->Parameters.QueryFile.FileInformationClass);
             Status = STATUS_INVALID_PARAMETER;
             goto exit;
     }
-    
+
     if (length < 0) {
         length = 0;
         Status = STATUS_BUFFER_OVERFLOW;
     }
-    
+
     Irp->IoStatus.Information = IrpSp->Parameters.QueryFile.Length - length;
 
-exit:    
+exit:
     TRACE("query_info returning %08x\n", Status);
-    
+
     return Status;
 }
 
-NTSTATUS STDCALL drv_query_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_QUERY_INFORMATION)
+_Function_class_(DRIVER_DISPATCH)
+NTSTATUS drv_query_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
     PIO_STACK_LOCATION IrpSp;
     NTSTATUS Status;
     fcb* fcb;
     device_extension* Vcb = DeviceObject->DeviceExtension;
     BOOL top_level;
-    
+
     FsRtlEnterFileSystem();
-    
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_query_information(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
+
     Irp->IoStatus.Information = 0;
-    
+
     TRACE("query information\n");
-    
+
     IrpSp = IoGetCurrentIrpStackLocation(Irp);
-    
-    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    
+
     fcb = IrpSp->FileObject->FsContext;
     TRACE("fcb = %p\n", fcb);
     TRACE("fcb->subvol = %p\n", fcb->subvol);
-    
+
     Status = query_info(fcb->Vcb, IrpSp->FileObject, Irp);
-    
+
+end:
     TRACE("returning %08x\n", Status);
-    
+
     Irp->IoStatus.Status = Status;
-    
+
     IoCompleteRequest( Irp, IO_NO_INCREMENT );
-    
-    ExReleaseResourceLite(&Vcb->tree_lock);
-    
-exit:
-    if (top_level) 
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
-    
+
     return Status;
 }
 
-NTSTATUS STDCALL drv_query_ea(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_QUERY_EA)
+_Function_class_(DRIVER_DISPATCH)
+NTSTATUS drv_query_ea(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
     NTSTATUS Status;
     BOOL top_level;
     device_extension* Vcb = DeviceObject->DeviceExtension;
@@ -4478,85 +3974,91 @@
     ccb* ccb;
     FILE_FULL_EA_INFORMATION* ffei;
     ULONG retlen = 0;
-    
-    TRACE("(%p, %p)\n", DeviceObject, Irp);
 
     FsRtlEnterFileSystem();
 
+    TRACE("(%p, %p)\n", DeviceObject, Irp);
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_query_ea(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
-    ffei = map_user_buffer(Irp);
+
+    ffei = map_user_buffer(Irp, NormalPagePriority);
     if (!ffei) {
         ERR("could not get output buffer\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (!FileObject) {
         ERR("no file object\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb) {
         ERR("no fcb\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     ccb = FileObject->FsContext2;
-    
+
     if (!ccb) {
         ERR("no ccb\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (Irp->RequestorMode == UserMode && !(ccb->access & (FILE_READ_EA | FILE_WRITE_EA))) {
         WARN("insufficient privileges\n");
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
+    if (fcb->ads)
+        fcb = ccb->fileref->parent->fcb;
+
     ExAcquireResourceSharedLite(fcb->Header.Resource, TRUE);
-    
+
     Status = STATUS_SUCCESS;
-    
+
     if (fcb->ea_xattr.Length == 0)
         goto end2;
-    
+
     if (IrpSp->Parameters.QueryEa.EaList) {
         FILE_FULL_EA_INFORMATION *ea, *out;
         FILE_GET_EA_INFORMATION* in;
-        
+
         in = IrpSp->Parameters.QueryEa.EaList;
         do {
             STRING s;
-            
+
             s.Length = s.MaximumLength = in->EaNameLength;
             s.Buffer = in->EaName;
-            
+
             RtlUpperString(&s, &s);
-            
+
             if (in->NextEntryOffset == 0)
                 break;
-            
+
             in = (FILE_GET_EA_INFORMATION*)(((UINT8*)in) + in->NextEntryOffset);
         } while (TRUE);
-        
+
         ea = (FILE_FULL_EA_INFORMATION*)fcb->ea_xattr.Buffer;
         out = NULL;
-        
+
         do {
             BOOL found = FALSE;
-            
+
             in = IrpSp->Parameters.QueryEa.EaList;
             do {
                 if (in->EaNameLength == ea->EaNameLength &&
@@ -4564,56 +4066,56 @@
                     found = TRUE;
                     break;
                 }
-                
+
                 if (in->NextEntryOffset == 0)
                     break;
-            
+
                 in = (FILE_GET_EA_INFORMATION*)(((UINT8*)in) + in->NextEntryOffset);
             } while (TRUE);
-            
+
             if (found) {
                 UINT8 padding = retlen % 4 > 0 ? (4 - (retlen % 4)) : 0;
-                
+
                 if (offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + ea->EaNameLength + 1 + ea->EaValueLength > IrpSp->Parameters.QueryEa.Length - retlen - padding) {
                     Status = STATUS_BUFFER_OVERFLOW;
                     retlen = 0;
                     goto end2;
                 }
-                
+
                 retlen += padding;
-            
+
                 if (out) {
-                    out->NextEntryOffset = offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + out->EaNameLength + 1 + out->EaValueLength + padding;
+                    out->NextEntryOffset = (ULONG)offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + out->EaNameLength + 1 + out->EaValueLength + padding;
                     out = (FILE_FULL_EA_INFORMATION*)(((UINT8*)out) + out->NextEntryOffset);
                 } else
                     out = ffei;
-                    
+
                 out->NextEntryOffset = 0;
                 out->Flags = ea->Flags;
                 out->EaNameLength = ea->EaNameLength;
                 out->EaValueLength = ea->EaValueLength;
                 RtlCopyMemory(out->EaName, ea->EaName, ea->EaNameLength + ea->EaValueLength + 1);
-                
-                retlen += offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + ea->EaNameLength + 1 + ea->EaValueLength;
-                
+
+                retlen += (ULONG)offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + ea->EaNameLength + 1 + ea->EaValueLength;
+
                 if (IrpSp->Flags & SL_RETURN_SINGLE_ENTRY)
                     break;
             }
-            
+
             if (ea->NextEntryOffset == 0)
                 break;
-            
+
             ea = (FILE_FULL_EA_INFORMATION*)(((UINT8*)ea) + ea->NextEntryOffset);
         } while (TRUE);
     } else {
         FILE_FULL_EA_INFORMATION *ea, *out;
         ULONG index;
-        
+
         if (IrpSp->Flags & SL_INDEX_SPECIFIED) {
             // The index is 1-based
             if (IrpSp->Parameters.QueryEa.EaIndex == 0) {
                 Status = STATUS_NONEXISTENT_EA_ENTRY;
-                goto end;
+                goto end2;
             } else
                 index = IrpSp->Parameters.QueryEa.EaIndex - 1;
         } else if (IrpSp->Flags & SL_RESTART_SCAN)
@@ -4620,69 +4122,70 @@
             index = ccb->ea_index = 0;
         else
             index = ccb->ea_index;
-        
+
         ea = (FILE_FULL_EA_INFORMATION*)fcb->ea_xattr.Buffer;
-        
+
         if (index > 0) {
             ULONG i;
-            
+
             for (i = 0; i < index; i++) {
                 if (ea->NextEntryOffset == 0) // last item
                     goto end2;
-                
+
                 ea = (FILE_FULL_EA_INFORMATION*)(((UINT8*)ea) + ea->NextEntryOffset);
             }
         }
-        
+
         out = NULL;
-        
+
         do {
             UINT8 padding = retlen % 4 > 0 ? (4 - (retlen % 4)) : 0;
-            
+
             if (offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + ea->EaNameLength + 1 + ea->EaValueLength > IrpSp->Parameters.QueryEa.Length - retlen - padding) {
                 Status = retlen == 0 ? STATUS_BUFFER_TOO_SMALL : STATUS_BUFFER_OVERFLOW;
                 goto end2;
             }
-            
+
             retlen += padding;
-        
+
             if (out) {
-                out->NextEntryOffset = offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + out->EaNameLength + 1 + out->EaValueLength + padding;
+                out->NextEntryOffset = (ULONG)offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + out->EaNameLength + 1 + out->EaValueLength + padding;
                 out = (FILE_FULL_EA_INFORMATION*)(((UINT8*)out) + out->NextEntryOffset);
             } else
                 out = ffei;
-                
+
             out->NextEntryOffset = 0;
             out->Flags = ea->Flags;
             out->EaNameLength = ea->EaNameLength;
             out->EaValueLength = ea->EaValueLength;
             RtlCopyMemory(out->EaName, ea->EaName, ea->EaNameLength + ea->EaValueLength + 1);
-            
-            retlen += offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + ea->EaNameLength + 1 + ea->EaValueLength;
-            
+
+            retlen += (ULONG)offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + ea->EaNameLength + 1 + ea->EaValueLength;
+
             if (!(IrpSp->Flags & SL_INDEX_SPECIFIED))
                 ccb->ea_index++;
-            
+
             if (ea->NextEntryOffset == 0 || IrpSp->Flags & SL_RETURN_SINGLE_ENTRY)
                 break;
-            
+
             ea = (FILE_FULL_EA_INFORMATION*)(((UINT8*)ea) + ea->NextEntryOffset);
         } while (TRUE);
     }
-    
+
 end2:
     ExReleaseResourceLite(fcb->Header.Resource);
-    
+
 end:
+    TRACE("returning %08x\n", Status);
+
     Irp->IoStatus.Status = Status;
     Irp->IoStatus.Information = NT_SUCCESS(Status) || Status == STATUS_BUFFER_OVERFLOW ? retlen : 0;
 
     IoCompleteRequest( Irp, IO_NO_INCREMENT );
 
-exit:
-    if (top_level) 
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
 
     return Status;
@@ -4695,7 +4198,9 @@
     LIST_ENTRY list_entry;
 } ea_item;
 
-NTSTATUS STDCALL drv_set_ea(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_SET_EA)
+_Function_class_(DRIVER_DISPATCH)
+NTSTATUS drv_set_ea(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
     device_extension* Vcb = DeviceObject->DeviceExtension;
     NTSTATUS Status;
     BOOL top_level;
@@ -4703,6 +4208,7 @@
     PFILE_OBJECT FileObject = IrpSp->FileObject;
     fcb* fcb;
     ccb* ccb;
+    file_ref* fileref;
     FILE_FULL_EA_INFORMATION* ffei;
     ULONG offset;
     LIST_ENTRY ealist;
@@ -4711,71 +4217,80 @@
     LIST_ENTRY* le;
     LARGE_INTEGER time;
     BTRFS_TIME now;
-    
-    TRACE("(%p, %p)\n", DeviceObject, Irp);
 
     FsRtlEnterFileSystem();
 
+    TRACE("(%p, %p)\n", DeviceObject, Irp);
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_set_ea(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
+
     if (Vcb->readonly) {
         Status = STATUS_MEDIA_WRITE_PROTECTED;
         goto end;
     }
-    
-    ffei = map_user_buffer(Irp);
+
+    ffei = map_user_buffer(Irp, NormalPagePriority);
     if (!ffei) {
         ERR("could not get output buffer\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     Status = IoCheckEaBufferValidity(ffei, IrpSp->Parameters.SetEa.Length, &offset);
     if (!NT_SUCCESS(Status)) {
         ERR("IoCheckEaBufferValidity returned %08x (error at offset %u)\n", Status, offset);
         goto end;
     }
-    
+
     if (!FileObject) {
         ERR("no file object\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb) {
         ERR("no fcb\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     ccb = FileObject->FsContext2;
-    
+
     if (!ccb) {
         ERR("no ccb\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (Irp->RequestorMode == UserMode && !(ccb->access & FILE_WRITE_EA)) {
         WARN("insufficient privileges\n");
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
+    if (fcb->ads) {
+        fileref = ccb->fileref->parent;
+        fcb = fileref->fcb;
+    } else
+        fileref = ccb->fileref;
+
     InitializeListHead(&ealist);
-    
+
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     if (fcb->ea_xattr.Length > 0) {
         ea = (FILE_FULL_EA_INFORMATION*)fcb->ea_xattr.Buffer;
-        
+
         do {
             item = ExAllocatePoolWithTag(PagedPool, sizeof(ea_item), ALLOC_TAG);
             if (!item) {
@@ -4783,39 +4298,39 @@
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end2;
             }
-            
+
             item->name.Length = item->name.MaximumLength = ea->EaNameLength;
             item->name.Buffer = ea->EaName;
-            
+
             item->value.Length = item->value.MaximumLength = ea->EaValueLength;
             item->value.Buffer = &ea->EaName[ea->EaNameLength + 1];
-            
+
             item->flags = ea->Flags;
-            
+
             InsertTailList(&ealist, &item->list_entry);
-            
+
             if (ea->NextEntryOffset == 0)
                 break;
-            
+
             ea = (FILE_FULL_EA_INFORMATION*)(((UINT8*)ea) + ea->NextEntryOffset);
         } while (TRUE);
     }
-    
+
     ea = ffei;
-    
+
     do {
         STRING s;
         BOOL found = FALSE;
-        
+
         s.Length = s.MaximumLength = ea->EaNameLength;
         s.Buffer = ea->EaName;
-        
+
         RtlUpperString(&s, &s);
-        
+
         le = ealist.Flink;
         while (le != &ealist) {
             item = CONTAINING_RECORD(le, ea_item, list_entry);
-            
+
             if (item->name.Length == s.Length &&
                 RtlCompareMemory(item->name.Buffer, s.Buffer, s.Length) == s.Length) {
                 item->flags = ea->Flags;
@@ -4824,10 +4339,10 @@
                 found = TRUE;
                 break;
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (!found) {
             item = ExAllocatePoolWithTag(PagedPool, sizeof(ea_item), ALLOC_TAG);
             if (!item) {
@@ -4835,63 +4350,63 @@
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end2;
             }
-            
+
             item->name.Length = item->name.MaximumLength = ea->EaNameLength;
             item->name.Buffer = ea->EaName;
-            
+
             item->value.Length = item->value.MaximumLength = ea->EaValueLength;
             item->value.Buffer = &ea->EaName[ea->EaNameLength + 1];
-            
+
             item->flags = ea->Flags;
-            
+
             InsertTailList(&ealist, &item->list_entry);
         }
-        
+
         if (ea->NextEntryOffset == 0)
             break;
-        
+
         ea = (FILE_FULL_EA_INFORMATION*)(((UINT8*)ea) + ea->NextEntryOffset);
     } while (TRUE);
-    
+
     // remove entries with zero-length value
     le = ealist.Flink;
     while (le != &ealist) {
         LIST_ENTRY* le2 = le->Flink;
-        
+
         item = CONTAINING_RECORD(le, ea_item, list_entry);
-        
+
         if (item->value.Length == 0) {
             RemoveEntryList(&item->list_entry);
             ExFreePool(item);
         }
-        
+
         le = le2;
     }
-    
+
     if (IsListEmpty(&ealist)) {
         fcb->ealen = 0;
-        
+
         if (fcb->ea_xattr.Buffer)
             ExFreePool(fcb->ea_xattr.Buffer);
-        
+
         fcb->ea_xattr.Length = fcb->ea_xattr.MaximumLength = 0;
         fcb->ea_xattr.Buffer = NULL;
     } else {
-        ULONG size = 0;
+        UINT16 size = 0;
         char *buf, *oldbuf;
-        
+
         le = ealist.Flink;
         while (le != &ealist) {
             item = CONTAINING_RECORD(le, ea_item, list_entry);
-            
+
             if (size % 4 > 0)
                 size += 4 - (size % 4);
-            
-            size += offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + item->name.Length + 1 + item->value.Length;
-            
+
+            size += (UINT16)offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + item->name.Length + 1 + item->value.Length;
+
             le = le->Flink;
         }
-        
+
         buf = ExAllocatePoolWithTag(PagedPool, size, ALLOC_TAG);
         if (!buf) {
             ERR("out of memory\n");
@@ -4898,86 +4413,87 @@
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end2;
         }
-        
+
         oldbuf = fcb->ea_xattr.Buffer;
-        
+
         fcb->ea_xattr.Length = fcb->ea_xattr.MaximumLength = size;
         fcb->ea_xattr.Buffer = buf;
-        
+
         fcb->ealen = 4;
         ea = NULL;
-        
+
         le = ealist.Flink;
         while (le != &ealist) {
             item = CONTAINING_RECORD(le, ea_item, list_entry);
-            
+
             if (ea) {
-                ea->NextEntryOffset = offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + ea->EaNameLength + ea->EaValueLength;
-                
+                ea->NextEntryOffset = (ULONG)offsetof(FILE_FULL_EA_INFORMATION, EaName[0]) + ea->EaNameLength + ea->EaValueLength;
+
                 if (ea->NextEntryOffset % 4 > 0)
                     ea->NextEntryOffset += 4 - (ea->NextEntryOffset % 4);
-                
+
                 ea = (FILE_FULL_EA_INFORMATION*)(((UINT8*)ea) + ea->NextEntryOffset);
             } else
                 ea = (FILE_FULL_EA_INFORMATION*)fcb->ea_xattr.Buffer;
-            
+
             ea->NextEntryOffset = 0;
             ea->Flags = item->flags;
-            ea->EaNameLength = item->name.Length;
+            ea->EaNameLength = (UCHAR)item->name.Length;
             ea->EaValueLength = item->value.Length;
-            
+
             RtlCopyMemory(ea->EaName, item->name.Buffer, item->name.Length);
             ea->EaName[item->name.Length] = 0;
             RtlCopyMemory(&ea->EaName[item->name.Length + 1], item->value.Buffer, item->value.Length);
-            
+
             fcb->ealen += 5 + item->name.Length + item->value.Length;
-            
+
             le = le->Flink;
         }
-        
+
         if (oldbuf)
             ExFreePool(oldbuf);
     }
-    
+
     fcb->ea_changed = TRUE;
-    
+
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
 
     fcb->inode_item.transid = Vcb->superblock.generation;
     fcb->inode_item.sequence++;
-    
+
     if (!ccb->user_set_change_time)
         fcb->inode_item.st_ctime = now;
-    
+
     fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fcb);
-    
-    send_notification_fileref(ccb->fileref, FILE_NOTIFY_CHANGE_EA, FILE_ACTION_MODIFIED);
-    
+
+    send_notification_fileref(fileref, FILE_NOTIFY_CHANGE_EA, FILE_ACTION_MODIFIED, NULL);
+
     Status = STATUS_SUCCESS;
-    
+
 end2:
     ExReleaseResourceLite(fcb->Header.Resource);
-    
+
     while (!IsListEmpty(&ealist)) {
         le = RemoveHeadList(&ealist);
-        
+
         item = CONTAINING_RECORD(le, ea_item, list_entry);
-        
+
         ExFreePool(item);
     }
-    
+
 end:
+    TRACE("returning %08x\n", Status);
+
     Irp->IoStatus.Status = Status;
     Irp->IoStatus.Information = 0;
 
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
-    
-exit:
-    if (top_level) 
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
 
     return Status;
